/* GCC */
#include <iostream>
#include <cmath>
#include <string>
#include <algorithm>
#include <cstdio>
#include <vector>
#include <queue>

using namespace std;

struct figure {
    int cell_cnt, minx, miny, maxx, maxy;
    vector < pair <int, int> > coords;
    figure(): minx(2e9), miny(2e9){};
    unsigned long long Hash[8];
} F[250];

void transfer(int id, int type) {
    if(!type)
        return;
    for(int j = 0; j < F[id].cell_cnt; j++) {
        if(type == 1)
            F[id].coords[j].first = F[id].maxx - F[id].coords[j].first;
        if(type == 2)
            F[id].coords[j].second = F[id].maxy - F[id].coords[j].second;
        if(type == 3)
            F[id].coords[j] = make_pair(F[id].maxx - F[id].coords[j].first, F[id].maxy - F[id].coords[j].second);
        if(type == 4)
            F[id].coords[j] = make_pair(F[id].coords[j].second, F[id].coords[j].first);
        if(type == 5)
            F[id].coords[j] = make_pair(F[id].maxy - F[id].coords[j].second, F[id].coords[j].first);
        if(type == 6)
            F[id].coords[j] = make_pair(F[id].coords[j].second, F[id].maxx - F[id].coords[j].first);
        if(type == 7)
            F[id].coords[j] = make_pair(F[id].maxy - F[id].coords[j].second, F[id].maxx - F[id].coords[j].first);
    }
}

int Go[4][2] = { {0, 1}, {0, -1}, {1, 0}, {-1, 0} };
int N, Fcnt, color[550], Size[550], samecnt;
char A[550][550];

void P_f(int id) {
    for(int i = 0; i < F[id].cell_cnt; i++) {
        F[id].coords[i].first = F[id].minx;
        F[id].coords[i].second = F[id].miny;
    }

    F[id].maxx = F[id].minx;
    F[id].maxy = F[id].miny;

    for(int i = 0; i < 8; i++) {
        transfer(id, i);
        sort(F[id].coords.begin(), F[id].coords.end());
        for(int j = 0; j < F[id].cell_cnt; j++)
            F[id].Hash[i] = F[id].Hash[i] * 101 + F[id].coords[j].first * N + F[id].coords[j].second + 1;
        transfer(id, i);
    }
}

int get_root(int v) {
    if(color[v] == v) return v;
    return color[v] = get_root(color[v]);
}

void unite(int v, int u) {
    v = get_root(v);
    u = get_root(u);
    if(Size[v] < Size[u])
        swap(v, u);
    Size[v] += Size[u];
    color[u] = color[v];
}

bool P_s(int i, int j) {
    if(get_root(i) == get_root(j))
            return false;
    if(F[i].cell_cnt != F[j].cell_cnt)
        return false;
    if( ((F[i].maxx == F[j].maxx) && (F[i].maxy == F[j].maxy)) || ((F[i].maxx == F[j].maxy) && (F[i].maxy == F[j].maxx)) )
        return true;
}

bool cheak(int id1, int id2) {
    for(int i = 0; i < 8; i++)
        for(int j = 0; j < 8; j++)
            if(F[id1].Hash[i] == F[id2].Hash[j])
                return true;
    return false;
}



int main() {
    freopen("test.in", "r", stdin);
    freopen("test.out", "w", stdout);
    cin >> N;
    for(int i = 0; i < N; i++)
        gets(A[i]);
    for(int i = 0; i < N; i++)
        for(int j = 0; j < N; j++)
            if(A[i][j] == '*') {
                queue< pair<int, int> > q;
                q.push(make_pair(i, j));
                A[i][j] = '.';
                while(!q.empty()) {
                    int c_x = q.front().first;
                    int c_y = q.front().second;
                    F[Fcnt].cell_cnt++;
                    F[Fcnt].coords.push_back(make_pair(c_x, c_y));
                    F[Fcnt].maxx = max(F[Fcnt].maxx, c_x);
                    F[Fcnt].maxy = max(F[Fcnt].maxy, c_y);
                    F[Fcnt].minx = min(F[Fcnt].minx, c_x);
                    F[Fcnt].miny = min(F[Fcnt].miny, c_y);
                    q.pop();
                    for(int k = 0; k < 4; k++) {
                        int n_x = c_x + Go[k][0];
                        int n_y = c_y + Go[k][1];
                        if(n_x >= 0 && n_y >= 0 && A[n_x][n_y] == '*') {
                                A[n_x][n_y] = '.';
                                q.push(make_pair(n_x, n_y));
                        }
                    }
                }
            P_f(Fcnt);
            Fcnt++;
            };
    for(int i = 0; i < Fcnt; i++)
        color[i] = i, Size[i] = 1;
    for(int i = 0; i < Fcnt; i++)
        for(int j = i + 1; j < Fcnt; j++)
            if(P_s(i, j) && cheak(i, j)) {
                unite(i, j);
                samecnt++;
            }
    cout << Fcnt << ' ' << Fcnt - samecnt << endl;
}
