/* GCC */
#include <iostream>
#include <vector>
#include <string>
#include <fstream>

using namespace std;

const int MAX=530, INF=530;

int vis[MAX][MAX];

struct shape
{
    int n, m, cnt;
    int arr[MAX][MAX];
    shape(): n(0), m(0), cnt(0) {}
    shape(int u, int l, int d, int r, int id, int c)
    {
        n=d-u+1, m=r-l+1;
        cnt=c;
        for(int i=u; i<=d; ++i)
            for(int j=l; j<=r; ++j)
                arr[i-u][j-l]=(vis[i][j]==id);
    }
    void output()
    {
        cout << n << " " << m << " " << cnt << endl;
        for(int i=0; i<n; ++i)
        {
            for(int j=0; j<m; ++j)
                cout << arr[i][j];
            cout << endl;
        }
    }
};

bool are_equal(shape& u, shape& v)
{
    bool flag;
    /// straightforward
    if(u.n==v.n&&u.m==v.m)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[i][j])
                    flag=false;
        if(flag) return true;
    }
    /// horizontal symmetry
    if(u.n==v.n&&u.m==v.m)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[u.n-i-1][j])
                    flag=false;
        if(flag) return true;
    }
    /// vertical symmetry
    if(u.n==v.n&&u.m==v.m)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[i][u.m-j-1])
                    flag=false;
        if(flag) return true;
    }
    /// turn at 90 degrees
    if(u.n==v.m&&u.m==v.n)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[j][i])
                    flag=false;
        if(flag) return true;
    }
    /// turn at 180 degrees
    if(u.n==v.n&&u.m==v.m)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[u.n-i-1][u.m-j-1])
                    flag=false;
        if(flag) return true;
    }
    /// turn at 270 degrees
    if(u.n==v.m&&u.m==v.n)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[u.m-j-1][u.n-i-1])
                    flag=false;
        if(flag) return true;
    }
    /// turn at 90 degrees and vertical symmetry
    if(u.n==v.m&&u.m==v.n)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[j][u.n-i-1])
                    flag=false;
        if(flag) return true;
    }
    /// turn at 270 degrees and vertical symmetry
    if(u.n==v.m&&u.m==v.n)
    {
        flag=true;
        for(int i=0; i<u.n; ++i)
            for(int j=0; j<u.m; ++j)
                if(u.arr[i][j]!=v.arr[u.m-j-1][i])
                    flag=false;
        if(flag) return true;
    }
    return false;
}

int n, cnt, l, u, r, d;
bool use[MAX];
string in[MAX];
shape all[249];
int pnt;

void dfs(int x, int y, int colour)
{
    vis[x][y]=colour;
    ++cnt;
    l=min(l, x);
    r=max(r, x);
    u=min(u, y);
    d=max(d, y);
    if(x>0&&vis[x-1][y]==0&&in[x-1][y]!=' ') dfs(x-1, y, colour);
    if(x<n-1&&vis[x+1][y]==0&&in[x+1][y]!=' ') dfs(x+1, y, colour);
    if(y>0&&vis[x][y-1]==0&&in[x][y-1]!=' ') dfs(x, y-1, colour);
    if(y<n-1&&vis[x][y+1]==0&&in[x][y+1]!=' ') dfs(x, y+1, colour);
}

int main()
{
    ios::sync_with_stdio(0);
    ifstream cin("test.in");
    ofstream cout("test.out");
    cin >> n;
    getline(cin, in[0]);
    for(int i=0; i<n; ++i)
        getline(cin, in[i]);
    for(int i=0; i<n; ++i)
        for(int j=0; j<n; ++j)
        {
            if(!vis[i][j]&&in[i][j]!=' ')
            {
                l=u=INF;
                r=d=-INF;
                cnt=0;
                dfs(i, j, pnt+1);
                all[pnt++]=shape(l, u, r, d, pnt, cnt);
            }
        }
    int ans=pnt;
    for(int i=0; i<pnt; ++i)
        for(int j=i+1; j<pnt; ++j)
            if(!use[i]&&!use[j]&&are_equal(all[i], all[j]))
                use[j]=true, --ans;
    cout << pnt << " " << ans << endl;
    return 0;
}
