""" Python 3 """

fin = open('test.in')
fout = open('test.out', 'w')

def adj(m, i, j):
    if i > 0 and m[i-1][j]:
        yield i-1, j
    if i < n-1 and m[i+1][j]:
        yield i+1, j
    if j > 0 and m[i][j-1]:
        yield i, j-1
    if j < n-1 and m[i][j+1]:
        yield i, j+1

def shift(shape):
    minx = min(shape, key=lambda c: c[1])[1]
    miny = min(shape, key=lambda c: c[0])[0]
    for i in shape:
        i[0] -= miny
        i[1] -= minx

def rotate(shape):
    for i in shape:
        i[0], i[1] = i[1], -i[0]

def reflect(shape):
    for i in shape:
        i[0] = -i[0]

def check(i, j):
    global diff
    for k in range(4):
        if sorted(shapes[i]) == sorted(shapes[j]):
            diff -= 1
            del shapes[j]
            del size[j]
            return True
        elif k < 3:
            rotate(shapes[i])
            shift(shapes[i])
    return False
        
def dfs(m, i, j):
    visited[i][j] = 1
    shape.append([i, j])
    for u, v in adj(m, i, j):
        if not visited[u][v]:
            dfs(m, u, v)

n = int(fin.readline())
shapes = []
size = []           
table = []
visited = [[0 for j in range(n)] for i in range(n)]

for i in range(n):
    l = list(fin.readline())
    t = [0 if l[j] == ' ' else 1 for j in range(n)]
    table.append(t)
    
for i in range(n):
    for j in range(n):
        if table[i][j] and not visited[i][j]:
            shape = []
            dfs(table, i, j)
            shapes.append(shape)

for shape in shapes:
    shift(shape)
    minx = min(shape, key=lambda c: c[1])[1]
    miny = min(shape, key=lambda c: c[0])[0]
    maxx = max(shape, key=lambda c: c[1])[1]
    maxy = max(shape, key=lambda c: c[0])[0]
    size.append({maxx-minx, maxy-miny})

s = len(shapes)
diff = s
i = 0

while i < len(shapes):
    j = i+1
    while j < len(shapes):
        if size[i] == size[j]:
            flag = check(i, j)
            if not flag:
                reflect(shapes[i])
                shift(shapes[i])
                flag = check(i, j)
            if not flag:
                j += 1
        else:
            j += 1
    i += 1
                
fout.write(str(s)+' '+str(diff)+'\n')

fin.close()
fout.close()
